load('gl.mat');

for ind=1:1; %numel(wavs)
    wav = wavs{ind};
    sr = srs{ind};
    f0 = f0s{ind};

    ts = (0:length(wav)-1)/sr;

    figure
    plot(ts, wav, 'k');
    hold on;

    disp('Compute FPD');
    fpds = gl_compute_fpd(wav, sr, f0);
    plot(fpds_ori{ind}(:,end), fpds_ori{ind}(:,1:end-2), '--g');
    plot(fpds(:,end), fpds(:,1:end-2));
    plot(fpds(:,end), log2(fpds(:,end-1))-log2(440), 'r', 'LineWidth',2);
    disp('Check FPD computation validity');
    disp(sqrt(sum((fpds-fpds_ori{ind}).^2,1)));

    disp('Compute Rd using MSPD2');
    rds = gl_estim_rd_mspdsq(wav, sr, f0);
    plot(rds(:,end), rds(:,1), 'b', 'LineWidth',2);
    plot(rds_ori{ind}(:,end), rds_ori{ind}(:,1), 'g');
    plot(rds(:,end), log2(1./rds(:,3))-log2(440), ':r', 'LineWidth',4);
    disp('Check Rd computation validity');
    disp(sqrt(sum((rds-rds_ori{ind}).^2,1)));
end

disp('(If only zeros or very small values appeared, the provided functions should work properly)');
